package com.pgpool.tests;


import com.pgpool.domain.AuthData;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class Issue231 extends PgpoolTest {

	@Override
	public void runTest(AuthData authData) throws Exception {

		//java.sql.DriverManager.setLogWriter(new java.io.PrintWriter(System.out));


		String url = String.format("jdbc:postgresql://%s:%d/%s?loglevel=2", authData.getPgpoolHostname(), authData.getPgpoolPort(), authData.getDatabaseName());

		try (Connection conn = DriverManager.getConnection(url, authData.getDatabaseLogin(), authData.getDatabasePasswd())) {

			conn.setAutoCommit(false);
			// Note: It is supposed that the database postgres contains table "table".
			try (PreparedStatement stmt = conn.prepareStatement("select * from write_table where id = ? ")) {

				for (int i = 0; i < 100; i++) {
					stmt.setInt(1, i);
					stmt.executeQuery().close();

					//System.out.println(i);
				}
			}

			conn.commit();


		} catch (SQLException ex) {
			ex.printStackTrace();
			throw ex;
		}
	}

}
