package com.pgpool.tests;


import com.pgpool.domain.AuthData;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class Issue231_Z_1 extends PgpoolTest {
	@Override
	public void runTest(AuthData authData) throws Exception {

		//java.sql.DriverManager.setLogWriter(new java.io.PrintWriter(System.out));

		String url = String.format("jdbc:postgresql://%s:%d/%s?loglevel=2", authData.getPgpoolHostname(), authData.getPgpoolPort(), authData.getDatabaseName());
		try (Connection conn = DriverManager.getConnection(url, authData.getDatabaseLogin(), authData.getDatabasePasswd())) {

			try {
				conn.setAutoCommit(false);

				executeSelectStatement(conn, "select table_name from information_schema.tables it where it.table_type = 'BASE TABLE'");
				conn.commit();

				executeSelectStatement(conn, "select table_name from information_schema.tables it where it.table_type = 'BASE TABLE'");
				conn.commit();

				executeSelectStatement(conn, "select table_name from information_schema.tables it where it.table_type = 'BASE TABLE'");
				conn.commit();

				executeSelectStatement(conn, "select table_name from information_schema.tables it where it.table_type = 'BASE TABLE'");
				conn.rollback();
			} catch (SQLException ex) {
				if (!conn.isClosed())
					conn.rollback();

				throw new RuntimeException(ex);
			}
		}
	}

	private void executeSelectStatement(Connection conn, String statement) throws Exception {

		try (PreparedStatement stmt = conn.prepareStatement(statement)) {
			stmt.executeQuery().close();
		}

	}
}
