package com.pgpool.tests;


import com.pgpool.domain.AuthData;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class TestPreparedStatement extends PgpoolTest {

	@Override
	public void runTest(AuthData authData) throws Exception {

		//java.sql.DriverManager.setLogWriter(new java.io.PrintWriter(System.out));


		String url = String.format("jdbc:postgresql://%s:%d/%s", authData.getPgpoolHostname(), authData.getPgpoolPort(), authData.getDatabaseName());
		for (int i = 0; i < 1; i++) {
			try (Connection conn = DriverManager.getConnection(url, authData.getDatabaseLogin(), authData.getDatabasePasswd())) {

				conn.setAutoCommit(false);
				// Note: It is supposed that the database postgres contains table "table".
//                Statement stmtReq = conn.createStatement();
//                stmtReq.execute("set statement_timeout to 30");
//                stmtReq.close();


				List<String> reqs = new ArrayList<>();
				reqs.add(
						"SELECT  typtype   FROM " +
								"pg_catalog.pg_type   LEFT   JOIN (select ns.oid as nspoid, ns.nspname, r.r           from pg_namespace as ns           join ( select s.r, (current_schemas(false))[s.r] " +
								"as nspname                    from generate_series(1, array_upper(current_schemas(false), 1)) as s(r) ) as r          using ( nspname )        ) as sp     ON sp.nspoid " +
								"= typnamespace  WHERE typname = ?  ORDER BY sp.r, pg_type.oid DESC LIMIT 1");

				for (String request : reqs) {
					try (PreparedStatement stmt = conn.prepareStatement(request)) {
						stmt.setQueryTimeout(30);
						for (int k = 0; k < 100; k++) {
							stmt.setString(1, "123" + k);
							stmt.executeQuery().close();
						}
					}
				}


				//          conn.commit();


//                for (int j = 0; j < 10; j++)
//                    try (PreparedStatement stmt = conn.prepareStatement("update hosts set host_id = host_id")) {
//                        stmt.executeUpdate();
//                    }


				try (PreparedStatement stmt = conn.prepareStatement("select current_schema()")) {
					stmt.setQueryTimeout(30);
					for (int j = 0; j < 10; j++) {
						//         stmt.setInt(1, 1);
						stmt.executeQuery().close();
					}
				}


				conn.commit();


			} catch (SQLException ex) {
				ex.printStackTrace();

				throw ex;
			}
		}
	}
}
