package com.pgpool.tests;


import com.pgpool.domain.AuthData;

import java.util.List;

public class TestStarter {

	private static final int TEST_ITERATIONS = 1000;

	public static void main(String[] args) throws Exception {

		if (args.length != 6) {
			System.out.println("required parameters not passed");
			return;
		}

		String hostname = args[0];// "10.28.78.115";
		int pgport = Integer.parseInt(args[1]);// "5432";
		String database = args[2]; // "oss";
		String username = args[3]; // "oss";
		String password = args[4]; // "H76iOavIst0EJ3";
		String testTypeName = args[5]; // Id of the test e.g. 231 or 271

		AuthData authData = new AuthData();

		authData.setPgpoolHostname(hostname);
		authData.setPgpoolPort(pgport);

		authData.setDatabaseName(database);
		authData.setDatabaseLogin(username);
		authData.setDatabasePasswd(password);

		PgpoolTest.TestType testType = PgpoolTest.TestType.fromId(testTypeName);
		final List<PgpoolTest> tests = TestsFactory.createTest(testType);

		//java.sql.DriverManager.setLogWriter(new java.io.PrintWriter(System.out));

		for (int i = 0; i < TEST_ITERATIONS; i++) {
			System.out.println(String.format("Test iteration '%d'", i));

			for (PgpoolTest test : tests) {
				test.runTest(authData);
			}
		}
	}


}
