package com.pgpool.tests;


import java.util.ArrayList;
import java.util.List;

public class TestsFactory {

	public static List<PgpoolTest> createTest(PgpoolTest.TestType testType) {

		List<PgpoolTest> tests = new ArrayList<>();

		switch (testType) {
			case ISSUE_231:
				tests.add(new Issue231());
				tests.add(new Issue231_Z_1());
				tests.add(new TestPreparedStatement());

				break;

			case ISSUE_271:
				//tests.add(new Issue271());
				tests.add(new Issue271_SingleThread());

				break;

			default:
				throw new IllegalArgumentException("Unprocessed enum constant :" + testType.name());
		}

		return tests;
	}
}
